// Copyright (c) 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/make_names.h.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/blink/renderer/modules/event_target_modules_names.json5


#ifndef THIRD_PARTY_BLINK_RENDERER_MODULES_EVENT_TARGET_MODULES_NAMES_H_
#define THIRD_PARTY_BLINK_RENDERER_MODULES_EVENT_TARGET_MODULES_NAMES_H_

#include "third_party/blink/renderer/platform/wtf/text/atomic_string.h"
#include "third_party/blink/renderer/platform/platform_export.h"

namespace blink {
namespace event_target_names {

extern const WTF::AtomicString& kAudioContext;
extern const WTF::AtomicString& kAudioNode;
extern const WTF::AtomicString& kBackgroundFetchRegistration;
extern const WTF::AtomicString& kBatteryManager;
extern const WTF::AtomicString& kBluetooth;
extern const WTF::AtomicString& kBluetoothDevice;
extern const WTF::AtomicString& kBluetoothRemoteGATTCharacteristic;
extern const WTF::AtomicString& kCookieStore;
extern const WTF::AtomicString& kDelegatedInkTrail;
extern const WTF::AtomicString& kFileWriter;
extern const WTF::AtomicString& kGPUDevice;
extern const WTF::AtomicString& kHID;
extern const WTF::AtomicString& kHIDDevice;
extern const WTF::AtomicString& kHTMLVideoElementPictureInPicture;
extern const WTF::AtomicString& kIDBDatabase;
extern const WTF::AtomicString& kIDBOpenDBRequest;
extern const WTF::AtomicString& kIDBRequest;
extern const WTF::AtomicString& kIDBTransaction;
extern const WTF::AtomicString& kIdleDetector;
extern const WTF::AtomicString& kImageCapture;
extern const WTF::AtomicString& kMIDIAccess;
extern const WTF::AtomicString& kMIDIInput;
extern const WTF::AtomicString& kMIDIPort;
extern const WTF::AtomicString& kMediaDevices;
extern const WTF::AtomicString& kMediaKeySession;
extern const WTF::AtomicString& kMediaRecorder;
extern const WTF::AtomicString& kMediaSource;
extern const WTF::AtomicString& kMediaStream;
extern const WTF::AtomicString& kMediaStreamTrack;
extern const WTF::AtomicString& kNDEFReader;
extern const WTF::AtomicString& kNetworkInformation;
extern const WTF::AtomicString& kNotification;
extern const WTF::AtomicString& kPaymentRequest;
extern const WTF::AtomicString& kPermissionStatus;
extern const WTF::AtomicString& kPictureInPictureWindow;
extern const WTF::AtomicString& kPresentationAvailability;
extern const WTF::AtomicString& kPresentationConnection;
extern const WTF::AtomicString& kPresentationConnectionList;
extern const WTF::AtomicString& kPresentationRequest;
extern const WTF::AtomicString& kRTCDTMFSender;
extern const WTF::AtomicString& kRTCDataChannel;
extern const WTF::AtomicString& kRTCDtlsTransport;
extern const WTF::AtomicString& kRTCIceTransport;
extern const WTF::AtomicString& kRTCPeerConnection;
extern const WTF::AtomicString& kRTCQuicStream;
extern const WTF::AtomicString& kRTCQuicTransport;
extern const WTF::AtomicString& kRTCSctpTransport;
extern const WTF::AtomicString& kRemotePlayback;
extern const WTF::AtomicString& kSMSReceiver;
extern const WTF::AtomicString& kScreenOrientation;
extern const WTF::AtomicString& kSensor;
extern const WTF::AtomicString& kSerial;
extern const WTF::AtomicString& kServiceWorker;
extern const WTF::AtomicString& kServiceWorkerContainer;
extern const WTF::AtomicString& kServiceWorkerGlobalScope;
extern const WTF::AtomicString& kServiceWorkerRegistration;
extern const WTF::AtomicString& kSourceBuffer;
extern const WTF::AtomicString& kSourceBufferList;
extern const WTF::AtomicString& kSpeechRecognition;
extern const WTF::AtomicString& kSpeechSynthesis;
extern const WTF::AtomicString& kSpeechSynthesisUtterance;
extern const WTF::AtomicString& kUSB;
extern const WTF::AtomicString& kVirtualKeyboard;
extern const WTF::AtomicString& kWakeLockSentinel;
extern const WTF::AtomicString& kWebSocket;
extern const WTF::AtomicString& kXR;
extern const WTF::AtomicString& kXRLayer;
extern const WTF::AtomicString& kXRLightProbe;
extern const WTF::AtomicString& kXRSession;
extern const WTF::AtomicString& kXRSpace;

constexpr unsigned kModulesNamesCount = 70;

void InitModules();

}  // namespace event_target_names
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_MODULES_EVENT_TARGET_MODULES_NAMES_H_
